const winston = require('winston');

winston.emitErrs = true;

function getFilePath(module) {
    // using filename in log statements
    return module.filename.split('/').slice(-2).join('/');
}

function logger(module) {
    return new winston.Logger({
        transports: [
            new winston.transports.File({
                level: 'info',
                filename: `${process.cwd()}/logs/all.log`,
                handleException: true,
                json: false,
                maxSize: 5242880, // 5MB
                maxFiles: 2,
                colorize: false,
            }),
            new winston.transports.Console({
                level: 'debug',
                label: getFilePath(module),
                handleException: true,
                json: true,
                colorize: true,
            }),
        ],
        exitOnError: false,
    });
}

module.exports = logger;
