const express = require('express');

const xml = require('js2xmlparser');

const regionApp = express();

const libs = `${process.cwd()}/libs`;

const log = require(`${libs}/log`)(module);

const dbQuery = require(`${libs}/db/query_exec`);

function response(req, res) {
    if (req.query.format === 'csv') {
        res.csv(req.result);
    } else if (req.query.format === 'xml') {
        res.send(xml('result', JSON.stringify({ state: req.result })));
    } else {
        res.json({ result: req.result });
    }
}

regionApp.get('/', (req, res) => {
    const regionSql = 'SELECT * FROM regioes';
    dbQuery(regionSql).then((result) => {
        req.result = result;
        return response(req, res);
    }, (error) => {
        log.error(`[${req.originalUrl}] SQL query error: ${error}`);
        next('Internal error, request could not be satisfied at this moment. Please, try again later');
    });
});

regionApp.get('/:id', (req, res) => {
    const regionSql = 'SELECT * FROM regioes WHERE pk_regiao_id = ?';
    const regionId = parseInt(req.params.id, 10);
    dbQuery(regionSql, [regionId]).then((result) => {
        req.result = result;
        return response(req, res);
    }, (error) => {
        log.error(`[${req.originalUrl}] SQL query error: ${error}`);
        next('Internal error, request could not be satisfied at this moment. Please, try again later');
    });
});

module.exports = regionApp;
